program solve(input,output);
const eps:extended=1e-8;
var n,x1,y1,x2,y2:longint;
  d:extended;
  i,j,k:integer;
  xc,yc:array[1..100] of longint;
  alf:array[1..5000] of extended;
function alpha(i,j:integer):extended;
var ch,zn,a:extended;
begin
  ch:=sqr(xc[i]-x1)-sqr(xc[j]-x1)+
      sqr(yc[i]-y1)-sqr(yc[j]-y1);
  zn:=2*((x2-x1)*(xc[i]-xc[j])+(y2-y1)*(yc[i]-yc[j]));
  if abs(zn)<=eps then
  begin
    alpha:=-1.0;
    exit;
  end;
  a:=ch/zn;
  alpha:=a;
end;
procedure check(i,j:integer);
var x,y,a,r,rt:extended;
    t:integer;
begin
  a:=alpha(i,j);
  x:=x1+a*(x2-x1);
  y:=y1+a*(y2-y1);
  r:=sqrt(sqr(xc[i]-x)+sqr(yc[i]-y));
  for t:=1 to n do
    if (t<>i) and (t<>j) then
    begin
      rt:=sqrt(sqr(xc[t]-x)+sqr(yc[t]-y));
      if abs(rt-r)<=eps then
      begin
        writeln('wrong data 3 same distance');
        halt;
      end;
      if rt<r then
        exit;  
    end;
{  if (abs(a)<=eps) or (abs(a-1)<=eps) then
  begin
    writeln('wrong data too near',i,' ',j);
    halt;
  end; }
  if (a<0) or (a>1) then
    exit;
  inc(k);
  alf[k]:=a;
{  for t:=1 to k-1 do
  begin
    if abs(alf[t]-a)*d<2e-4 then
      begin
        writeln('wrong data too small');
        halt;
      end;
  end; }
end;
begin
  assign(input,'input.txt');
  reset(input);
  assign(output,'output.txt');
  rewrite(output);
  read(n,x1,y1,x2,y2);
  d:=sqrt(sqr(x1-x2)+sqr(y1-y2));
  for i:=1 to n do
    read(xc[i],yc[i]);
  k:=0;
  for i:=1 to n do
    for j:=i+1 to n do
      check(i,j);
  writeln(k);
  close(input);
  close(output);
end.
